/*

@@@BUILDINFO@@@ EMailerService.jsx 1.0.5  28-Apr-2009

*/



// Tue Apr 28 2009 13:01:22 GMT-0700



/*

@@@START_XML@@@

<?xml version="1.0" encoding="UTF-8"?>

<ScriptInfo xmlns:dc="http://purl.org/dc/elements/1.1/" xml:lang="en_US">

     <dc:title>Emailer Panel</dc:title>

     <dc:description>This script enables the core Emailer processing from the Emailer panel in Adobe Photoshop CS4.</dc:description>

</ScriptInfo>

@@@END_XML@@@

*/



// i didn't indent cuz that would be annoying

try {

	



// i didn't indent cuz that would be annoying

// only load this into Photoshop

if (BridgeTalk.appName == "photoshop") {

	

///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////

// // Some globals at the top for easy editing

var emailer = new Object;

emailer.showAlerts = true; // use this for debug purposes and not for normal alerts

emailer.JPEGQuality = 8;

 

emailer.runProcess = function( inParamsAsSource ) {

	try {



		emailer.cleanTempFolder( PhotoshopCS4Emailer.getTempScriptFolder() );



		PhotoshopCS4Emailer.clearLog();

		

		var s = "";

		

		var params = eval( inParamsAsSource );

		

		var config = {};



		config.recipient = unescape(params.etMailTo);

		config.subject = unescape(params.etSubject);

		config.mailServerName = unescape(params.etMailServerName);

		config.username = unescape(params.etUserName); 

		config.sender = unescape(params.etSenderAddress); 

		config.password = unescape(params.etPassword);

		config.messageText = unescape(params.etMessage);

		config.sendWithApp = params.cbSendWithApp;

		config.mailAppName = params.ddMailProgram;

		switch (config.mailAppName) {

			case "Microsoft Entourage": config.mailAppName = "Microsoft Entourage"; break;

			case "Mac Mail": config.mailAppName = "Mail"; break;

			default: config.mailAppName = "Outlook";

		}

		if (params.cbUseCustomPort) {

			config.POP = unescape(params.etPOP);

			config.SMTP = unescape(params.etSMTP);

		}

	

		config.filesToAttach = new  Array();

		

		if ( documents.length == 0 ) {

			//alert("Why did you run me if you have no files open?");

			s = emailer.stringToXML("No open documents");

			alert("No open documents")

			return s;

		}

		

		if ( params.cbSizeToFit ) {

			var unitWidth = emailer.stringToUnitValue( params.etSizeToFitW );

			var unitHeight = emailer.stringToUnitValue( params.etSizeToFitH );

		}



		var tempFolder = PhotoshopCS4Emailer.getTempScriptFolder();

		

		if (params.cbSendAll) {

			var currentActive = app.activeDocument;

			for ( var i = 0; i < documents.length; i++ ) {

				app.activeDocument = app.documents[i];

				var doc = app.activeDocument.duplicate();

				var splitUp = new FileFolderSplitter( app.documents[i].fullName.fsName );

				var uniqueFileName = CreateUniqueFileName( tempFolder + "/", splitUp.name, ".jpg" ); // was  + splitUp.extension );

				doc.flatten();

				if ( params.cbSizeToFit ) {

					var w = emailer.unitsToPixels( unitWidth.value, unitWidth.type, doc.resolution, doc.width.as("px") );

					var h = emailer.unitsToPixels( unitHeight.value, unitHeight.type, doc.resolution, doc.height.as("px") );

					FitImage( w, h, "Bicubic" );

				}

				if (params.cbConvert) {

					emailer.convertTosRGBProfile();

				}

				if ( params.cbSmartSharpen ) {

					emailer.webSharpen( doc );

				}

				emailer.mySave( uniqueFileName );

				doc.close( SaveOptions.DONOTSAVECHANGES );

				config.filesToAttach.push( new File( uniqueFileName ) );

			}

			app.activeDocument = currentActive;

		} else {

			var splitUp = new FileFolderSplitter( activeDocument.fullName.fsName );

			var doc = app.activeDocument.duplicate();

			var uniqueFileName = CreateUniqueFileName( tempFolder + "/", splitUp.name, ".jpg" ); // was  + splitUp.extension );

			doc.flatten();

			if ( params.cbSizeToFit ) {

				var w = emailer.unitsToPixels( unitWidth.value, unitWidth.type, doc.resolution, doc.width.as("px") );

				var h = emailer.unitsToPixels( unitHeight.value, unitHeight.type, doc.resolution, doc.height.as("px") );

				FitImage( w, h, "Bicubic" );

			}

			if (params.cbConvert) {

				emailer.convertTosRGBProfile();

			}

			if ( params.cbSmartSharpen ) {

				emailer.webSharpen( doc );

			}

			emailer.mySave( uniqueFileName );

			doc.close( SaveOptions.DONOTSAVECHANGES );

			config.filesToAttach.push( new File( uniqueFileName ) );

		}

	

		emailer.fitOnScreen();

	

		PhotoshopCS4Emailer.SendEmail( config );

		

		s = emailer.stringToXML("EMail message sent successfully!");

	}

	

	catch(e) { 

		if (emailer.showAlerts) alert(e + " : " + e.line); 

		s = emailer.errorToXML(e);

	}



	return s;

	

}



emailer.cleanTempFolder = function ( f ) {

	var a = f.getFiles();

	for (var i = 0; i < a.length; i++) {

		a[i].remove();

	}

}



// WARNING: inString must be valid XML

// TODO: should I do that now, what about on the swf end ?

emailer.stringToXML = function (inString) {

    var s = '<object>';

    s += emailer.propertyToXML(0, "error");

    s += emailer.propertyToXML(inString, "message");

    s += '</object>';

    return s;

}



// inError is a JSX error from a catch(e) 

emailer.errorToXML = function(inError) {

    var s = '<object>';

    s += emailer.propertyToXML(inError.number, "error");

    s += emailer.propertyToXML(inError.message, "message");

    s += emailer.propertyToXML(inError.line, "line");

    s += emailer.propertyToXML(inError.fileName, "fileName");

    s += '</object>';

    return s;

}



// convert a local type to something that can go back to SWF

emailer.propertyToXML = function(inProperty, inID) {

    var t = typeof inProperty;

    var s = '<property id="' + inID + '">';

    switch (t) {

        case "number":

            s += '<number>' + inProperty.toString() + '</number>';

            break;

        case "boolean":

            s += '<' + inProperty.toString() + '/>';

            break;

        case "string":

            s += '<string>' + inProperty.toString() + '</string>';

            break;

        // TODO figure this out

        case "object":

            //s += '<object>';

			//for (var i in inProperty) {

			//	s += emailer.propertyToXML(inProperty[i], i.toString());

			//}

			//s += '</object>';

            break;

        case "undefined":

            s += '<string>undefined</string>';

            break;

        default:

            if (emailer.showAlerts) alert('unknown type not supported: ' + t);

            break;

    }

    s += '</property>';

    return s;

}



////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////

// ADOBE SYSTEMS INCORPORATED

// Copyright 2008 Adobe Systems Incorporated

// All Rights Reserved

//

// NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the

// terms of the Adobe license agreement accompanying it.  If you have received this file from a

// source other than Adobe, then your use, modification, or distribution of it requires the prior

// written permission of Adobe.

/////////////////////////////////////////////////////////////////////////////



PhotoshopCS4EmailerGlobals = {};

PhotoshopCS4EmailerGlobals.verboseLogging = true;

PhotoshopCS4EmailerGlobals.logFile;



PhotoshopCS4Emailer.getTempScriptFolder = function()

{

	if (Folder.fs == "Windows") {

		var tempScriptFolder = Folder.temp;

	}

	else {

		var tempScriptFolder = Folder.userData;

	}

	tempScriptFolder = new Folder( tempScriptFolder.fsName + "/Adobe/Adobe Photoshop CS4/EMailer" );

	tempScriptFolder.create();

	return tempScriptFolder;

}



PhotoshopCS4Emailer.getLogFile = function() {

	if( typeof PhotoshopCS4EmailerGlobals.logFile == "undefined" ) 	{

		PhotoshopCS4EmailerGlobals.logFile =  new File( PhotoshopCS4Emailer.getTempScriptFolder().fsName + "/EmailerLog.txt" );

	}

	return PhotoshopCS4EmailerGlobals.logFile;

	

}



PhotoshopCS4Emailer.clearLog = function() {

	PhotoshopCS4Emailer.getLogFile();

	if( PhotoshopCS4EmailerGlobals.logFile && PhotoshopCS4EmailerGlobals.logFile.exists ) {

		PhotoshopCS4EmailerGlobals.logFile.remove();

	}

}



PhotoshopCS4Emailer.showLog = function () {

	PhotoshopCS4Emailer.getLogFile();

	if( PhotoshopCS4EmailerGlobals.logFile && PhotoshopCS4EmailerGlobals.logFile.exists ) {

		PhotoshopCS4EmailerGlobals.logFile.execute();

	} else {

		alert('No log file.')

	}

}



PhotoshopCS4Emailer.writeToLog = function( info )

{

		if( PhotoshopCS4EmailerGlobals.verboseLogging )

		{

			PhotoshopCS4Emailer.getLogFile();

			

			PhotoshopCS4EmailerGlobals.logFile.open("a");

			PhotoshopCS4EmailerGlobals.logFile.writeln( info );

			PhotoshopCS4EmailerGlobals.logFile.close();

			//$.writeln( info );

			//app.console( info );

			//app.console("\n");

		}

}



/**

* @class LoggingSocket

* Wrapps a Socket object, loging all the reads and writes.

*/

function LoggingSocket( socket )

{

	this.socket = socket;

}



LoggingSocket.prototype.log = function( info )

{

		PhotoshopCS4Emailer.writeToLog ( info );

}



LoggingSocket.prototype.read = function()

{

		var resp = this.socket.read();

		// this.log("read: " + resp );

		return resp;

		

}



LoggingSocket.prototype.write = function( bytes )

{

	var resp = this.socket.write( bytes );

	// this.log("write: " + bytes );

	// this.log("result: " + resp );

	if( resp < bytes.length )

	{

			PhotoshopCS4Emailer.writeToLog ("Atempting 2nd write! Errors?" + this.socket.error );

			resp = this.socket.write( bytes );

			// this.log("result2: " + resp );

	}

	return resp;

}



LoggingSocket.prototype.open = function( url )

{

	var resp = this.socket.open( url );

	// this.log("open: " + url );

	// this.log("result: " + resp );

	return resp;

}



LoggingSocket.prototype.close = function()

{

		var resp = this.socket.close();

		return resp;

}









/*

 @see BackgroundEmailer

 

  @constructor Constructor.

 */

function PhotoshopCS4Emailer( emailConfig )

{



	// alert("PhotoshopCS4Emailer created " + emailConfig.toSource());

	/**

	 The context in which this sample can run.

	 @type String

	*/

	this.requiredContext = "\tEnsure that Photoshop is running and set as the target and that you have supplied your own mail server details.\n";



	/** 

	  The host address for the mail server, for example mail.adomainname.com - 

	  NOTE: You must customize this with your own host address value.

	 @type String

	*/

	this.mailServerName = emailConfig.mailServerName; // "namail.corp.adobe.com"; // ; // ex: ;





	/** 

	 The username, not necessarily the email address,  to authorize with, for example 

	 testemail@adomainname.com - NOTE: You must customize this with your own username value.

	 @type String

	*/

	this.username = emailConfig.username; // ex:"dfranzen";

	



	/** 

	 The password for the username - NOTE: You must customize this with your own password value.

	 @type String

	*/

	this.password = emailConfig.password; // ex: "changeme";



	/** 

      The senders email address, for example testemail@adomainname.com 

	  - NOTE: You must customize this with your own email address.

	 @type String

	*/

	this.sender = emailConfig.sender; // ex: "dfranzen@adobe.com";

	



	/** 

       The address the email will be sent to, the receiver of the email - 

	   NOTE: You must customize this with your own recipient address.

	 @type String

	*/

	this.recipient = emailConfig.recipient; // ex: "david@pixelandink.com";





	/** 

	 The subject of the email

	 @type String

	*/

	this.subject = emailConfig.subject; // ex: "Email from Photoshop via PhotoshopCS4Emailer.jsx";

	

	/** 

       The port number for the SMTP server, for example port 25 - 

	   NOTE: You may need to customize this with your own port number.

	 @type int

	*/

	if( emailConfig.SMTP )

	{

		this.SMTP = emailConfig.SMTP;

		this.useCustomSmtpPort = true;

		

		// Let's just assume for now if they're specifying a custom SMTP port that it requires encryption (pretty good bet)

		this.useTlsEncryption = true;

	} else {

		this.SMTP =  25;

	}

	

	/** 

       The port number for the POP server, for example port 110 - 

	   NOTE: You may need to customize this with your own port number.

	 @type int

	*/

	if( emailConfig.POP )

	{

		this.POP = emailConfig.POP;

	} else {

		this.POP =  110;

	}



	/**

	 The socket object which this object uses to write to the wire

	 @type Socket

	*/

	this.realSocket = new Socket();

	this.socket = new LoggingSocket( this.realSocket );

	/**

	 The body text of the message

	 @type String

	*/

	this.message = "";

	

	/**

		An array of Photoshop Thumbnails to attach.

		@type Array

	*/

	this.thumbnailsToAttach = new Array();

	

	/**

	The boundary for attachments

	@type String

	*/

	this.boundary = "****=_NextPartMyBody_0000 " + new Date().getSeconds();



	// set the encoding for the socket

	//this.socket.encoding = "binary";

	this.socket.socket.encoding = "binary";

	

}



PhotoshopCS4EmailerGlobals.fullComputerName = null;



PhotoshopCS4EmailerGlobals.getFullComputerName = function()

{



	var curFolder = new File( $.fileName ).parent;

	var nameFile = new File( curFolder.fsName + "/FullComputerName.txt" );

	

	var baseCmd =  "net config workstation | FIND \"Full Computer name\"";

	

	if( Folder.fs == "Macintosh" )

	{

		var baseCmd = "hostname";

	}



	var cmd = baseCmd + " > \"" + nameFile.fsName + "\"";

	

	//$.writeln( cmd );



	var res = app.system( cmd );



	while( ! nameFile.exists )

	{

		$.sleep( 500 );

	}



	nameFile.open("r");

	var name = nameFile.read();

	nameFile.close();



	if( Folder.fs == "Windows" )

	{

			// The is "Full Comptuer name" followed by some number of spaces and the host name.

			// find where there are at least 2 spaces in a row.

			var spacesIdx = name.indexOf("  ");

			// trim off everything before the spaces

			name = name.substr( spacesIdx );

			

			// get rid of any other leading spaces

			while( name.indexOf(" ") == 0 )

			{

					name = name.substr( 1 );

			}

	}



	// get rid of a trailing newline

	var newLineIdx = name.indexOf("\n");

	if( newLineIdx > -1 )

	{

		name = name.substring( 0, newLineIdx );

	}



	//$.writeln( "\"" + name + "\"");



	return name;



}



function replaceAll( string, find, repl )

{

		var res = string;

		while ( res.indexOf( find ) > -1 )

		{

				res = res.replace( find, repl );

		}

		return res;

}

PhotoshopCS4Emailer.prototype.escapeForCommandLine = function( theString )

{

	if (theString == undefined) return '';



	var escaped = theString;

	if (this.isWindows) {

	    escaped = escaped.replace(/"/g, '\\"');

	    escaped = escaped.replace(/%/g, '%%');

	}

	else {

	    escaped = escaped.replace(/!/g, "\\!");

	    escaped = escaped.replace(/&/g, "\\&");

	    //escaped = escaped.replace(/ /g, "\\ ");

	}

	

	return escaped;

}



/**

* Sends the email and attachments by connecting to the server and authorizing via POP.

* Reestablishes the connection and sends the necessary commands to the SMTP server.

* If there are attachments to be sent, encodes them into Base64 and writes them to the socket.

* If any folders are selected in Photoshop, they are ignored.

*

* @return True if the mail was sent succesfully.

* @type Boolean

*/

PhotoshopCS4Emailer.prototype.send = function()

{

	var retval = false;

	var startDate = new Date();

	PhotoshopCS4Emailer.writeToLog ("IN PhotoshopCS4Emailer.send() = " + startDate);



	try

	{	

		var scriptsPathSegment = "Plug-ins/Panels/Emailer/scripts/";

		var outputFilename = "send_email_output.txt";

		var messageFilename = "send_email_message.txt";

		var semaphoreFilename = "send_email_semaphore.txt";

		var cmdString = "";

		

			

		// Basic host/port params

		if( ! PhotoshopCS4EmailerGlobals.fullComputerName )

		{

			PhotoshopCS4EmailerGlobals.fullComputerName = PhotoshopCS4EmailerGlobals.getFullComputerName();

		}

		PhotoshopCS4Emailer.writeToLog ("full computer name: " + PhotoshopCS4EmailerGlobals.fullComputerName);

		

		cmdString += " -d " + this.escapeForCommandLine(PhotoshopCS4EmailerGlobals.fullComputerName);

		cmdString += " -smtp " + this.escapeForCommandLine(this.mailServerName);

		cmdString += " -port " + this.escapeForCommandLine(this.SMTP.toString());

		

		

		// To

		/* Support multiple recipients

		 * check to see if the recipient string is for multiple-recipients.

		 * Accepted address demiminators are: space, colon, semi-colon, comma, slash, badkslach, or a tab.

		 */

		var rcpts =  this.recipient;

		rcpts = rcpts.replace(/(\w) (\w)/g, "$1,$2");

		rcpts = replaceAll( rcpts, ";", ",");

		rcpts = replaceAll( rcpts, ":", ",");

		rcpts = replaceAll( rcpts, "\\", ",");

		rcpts = replaceAll( rcpts, "/", ",");

		rcpts = replaceAll( rcpts, "\t", ",");

		rcpts = rcpts.replace(/ /g, ""); // Once all the delimiters are replaced, kill any remaining spaces

		cmdString += " -t " + this.escapeForCommandLine(rcpts) + " +cc +bc";

		

		// From

		cmdString += " -f " + this.escapeForCommandLine(this.sender);

		var subject = this.subject;

		if( ! subject )

		{

				subject = "";

		}

		cmdString += " -sub \"" + this.escapeForCommandLine(subject) + "\"";

		

		// Add attachments

		cmdString += this.getAttachmentsString();

		

		

		// Handle TLS encryption if necessary.

		if (this.useTlsEncryption) {

			cmdString += " -starttls";

		}

		// Handle authentication if necessary.

		cmdString += " -auth";

		cmdString += " -user " + this.escapeForCommandLine(this.username);

		cmdString += " -password " + this.escapeForCommandLine(this.password);

		

		

		// OS-specific variables

		var osFolderName = "mac/";

		var osLineFeed = "Unix";

		var scriptsPath = "../../../" + scriptsPathSegment;

		if (Folder.fs == "Windows") {

			osFolderName = "windows/";

			osLineFeed = "Windows";

			scriptsPath = scriptsPathSegment;

		}



		

		var messageFile = new File(scriptsPath + osFolderName + messageFilename);

		var outputFile = new File(scriptsPath + osFolderName + outputFilename);

		var semaphoreFile = new File(scriptsPath + osFolderName + semaphoreFilename);

		

		// Delete our temporary files first.

		outputFile.remove();

		semaphoreFile.remove();

		

		messageFile.lineFeed = "Windows";

		outputFile.lineFeed = osLineFeed;

		

		// Write the email message text to a file or the command line.

		var messageText = this.messageText;

		if( ! messageText )

		{

			messageText = "";

		}

		

		if (messageFile.open("w")) {

			messageFile.writeln(messageText);

			messageFile.writeln("");

			messageFile.close();

			

			cmdString += " -m " + messageFilename + ",text/plain";

		}

		else {

			// Hmm... can't open the message file for writing - try to at least spew it out on the command line.

			cmdString += " -M \"" + this.escapeForCommandLine(messageText) + "\"";

		}

		

		// OS-specific blocks here for the actual execution of the mailsend command...

		if (Folder.fs == "Windows") {

			// Write out the batch file that calls mailsend.

	    	var cmdStringFile = new File(scriptsPath + osFolderName + "send_email.bat");

	    	cmdStringFile.lineFeed = osLineFeed;

		    

			var scriptFolderPath = scriptsPath.replace(/\//g, '\\') + osFolderName.replace(/\//g, '\\');

			if (cmdStringFile.open("w")) {

				cmdStringFile.writeln("@echo off");

				cmdStringFile.writeln("echo Sending E-Mail from Adobe Photoshop CS4...");

				cmdStringFile.writeln("cd " + scriptFolderPath);

				cmdStringFile.writeln("mailsend" + cmdString + " > " + outputFilename);

				cmdStringFile.writeln("echo. > " + semaphoreFilename);

				cmdStringFile.close();

				

				cmdStringFile.execute();

			}

			else {

				throw new Error("Unable to send email. Please double-check your settings and try again.");

			}

		}

		else {

			// Write out the shell script that calls mailsend.

	    	var cmdStringFile = new File(scriptsPath + osFolderName + "send_email.sh");

	    	cmdStringFile.lineFeed = osLineFeed;

		    

			if (cmdStringFile.open("w")) {

				cmdStringFile.writeln("#!/bin/sh");

				cmdStringFile.writeln("./mailsend" + cmdString + " 2>&1 | tee " + outputFilename);

				cmdStringFile.writeln("touch " + semaphoreFilename);

				cmdStringFile.close();

			}

			

			var cmdFile = new File(scriptsPath + osFolderName + "Send EMail from Adobe Photoshop CS4.app");

			cmdFile.execute();

		}

		

		// Wait for the semaphore file to get written...

		var secondsPerCheck = 0.5;

		var secondsToWaitPerImage = 60;

		var maxChecks = (secondsToWaitPerImage / secondsPerCheck) * this.attachmentCount;

		while (true) {

			if (semaphoreFile.exists) {

				break;

			}

			else if (maxChecks == 0) {

				// Create the semaphore file now so that other external processes monitoring this file will quit.

				if (semaphoreFile.open("w")) {

					semaphoreFile.writeln("");

					semaphoreFile.close();

				}

				

				throw new Error("Timed out after waiting " + (secondsToWaitPerImage * this.attachmentCount) + " seconds. " +

						"Your email message may not have been sent correctly. Please check with the recipient to varify that it was received.");

			}

			else {

				maxChecks--;

				$.sleep(1000 * secondsPerCheck);

			}

		}

		

		// Now read in the contents of our output text file...

		var output = "";

		if (outputFile.exists) {

			if (outputFile.open("r")) {

				output = outputFile.read();

				outputFile.close();

			}

			if (output.indexOf("Error: ") > -1) {

				// If the error message is about STARTTLS and we haven't tried encryption on this attempt, let's retry with that flag set...

				if ( ! this.useTlsEncryption && output.indexOf("STARTTLS") > -1) {

					this.useTlsEncryption = true;

					//alert("retrying with encryption...");

					this.send();

				}

				else {

					//alert(output);

					output = output.replace(/Error: /, "");

					throw new Error("Unable to send email: " + output);

				}

			}

		}

		else {

			throw new Error("Unable to send email. Please double-check your settings and try again.");

		}

		



        var endDate = new Date();

        PhotoshopCS4Emailer.writeToLog ("OUT PhotoshopCS4Emailer.send() = " + endDate);

		

		PhotoshopCS4Emailer.ReportStatus( localize("$$$/BridgeEmailerExtension/status/done=E-Mail Sent") );

		

		return retval;

	

	}

	catch (e)

	{

		PhotoshopCS4Emailer.writeToLog ("PhotoshopCS4Emailer: ERROR: " + e + ":" + e.line);

		throw( e );

	}

}



/**

  Adds attachments to the email being sent

*/

PhotoshopCS4Emailer.prototype.getAttachmentsString = function()

{

	var attachmentsString = "";

	var startDate = new Date();

	PhotoshopCS4Emailer.writeToLog ("IN PhotoshopCS4Emailer.getAttachmentsString() = " + startDate);



	//var sels = app.document.selections;

	var sels = new Array();

	this.attachmentCount = 0;

	

	if( this.thumbnailsToAttach )

	{

		for( t in this.thumbnailsToAttach )

		{

			sels.push( this.thumbnailsToAttach[t] );

		}

	} 

	if( this.filesToAttach )

	{

		for( f in this.filesToAttach )

		{

			sels.push( this.filesToAttach[f] );

		}

	}

	



	// Get the file selected in Photoshop

	if(sels.length != 0)

	{

		// Loop through all selected thumbnails and email the images as attachments

		for(var j = 0;j < sels.length;j++)

		{

			var next = sels[j];

			var theFile = null;

			if ( next instanceof File ) 

			{

				theFile = next;				

			} else {

				continue;

			}

			// Increment the attachment count so we can easily know how many there are later on...

			this.attachmentCount++;

			

			PhotoshopCS4Emailer.writeToLog ("    attaching:" + theFile.fsName);

			//attachmentsString += " -attach " + this.escapeForCommandLine(theFile.fsName) + ",image/jpeg,a";

			attachmentsString += " -attach \"" + this.escapeForCommandLine(theFile.fsName) + "\"";

		}

	}

	return attachmentsString;

}



//dfranzen

PhotoshopCS4Emailer.prototype.sendMessage = function( messageConfig )

{

	if (messageConfig.sendWithApp) {

		

		PhotoshopCS4Emailer.sendMailWithApplication( messageConfig );

		

	} else {



	    this.isWindows = (File.fs == "Windows");

		this.recipient = messageConfig.recipient;

		this.subject = messageConfig.subject;

		this.messageText = messageConfig.messageText; // the part the user wrote

		if( messageConfig.thumbnailsToAttach )

		{

			this.thumbnailsToAttach = messageConfig.thumbnailsToAttach;

		} else {

			if( messageConfig.filesToAttach )

			{

				this.filesToAttach = messageConfig.filesToAttach;

			} else {

				this.thumbnailsToAttach = new Array();

			}

		}

	

		try {

			//this.buildMessage();

			this.send();

		} catch ( e ) {

			PhotoshopCS4Emailer.writeToLog ("ERROR in sendMessage(): " + e  + ":" + e.line);

			throw( e );

		}

	}

}



PhotoshopCS4Emailer.sendMailWithApplication = function( messageConfig )

{

	if( Folder.fs != "Macintosh" && Folder.fs != "Windows") {

		throw new Error("Sending E-mail with a client is not yet supported on " + Folder.fs );

	}

	

	var myHome = app.path.toString() + "/Plug-Ins/Panels/EMailer"; // File($.fileName).parent;

	var myInstructions = File(myHome + "/DrBrownMail.txt");

	if (myInstructions.open("w")) {

		// myInstructions.writeln( messageConfig.recipient );

		// myInstructions.writeln( messageConfig.subject );

		myInstructions.writeln( messageConfig.mailAppName );

		for (var i = 0; i < messageConfig.filesToAttach.length; i++) {

			myInstructions.writeln( File( messageConfig.filesToAttach[i] ).fsName );

		}

		myInstructions.close();

	} else {

		alert("Could not create instructions");

	}

	

	if( Folder.fs == "Macintosh") {

		this.sendMailViaAppleScript(messageConfig, myHome);

	}

	else {

		this.sendMailViaWindowsScriptHost(messageConfig, myHome);

	}

}



PhotoshopCS4Emailer.sendMailViaWindowsScriptHost = function( messageConfig, myHome )

{

	File( myHome + "/scripts/windows/send_email_with_outlook.bat").execute();

}



PhotoshopCS4Emailer.sendMailViaAppleScript = function( messageConfig, myHome ) // mailAppName, thumbnailsToAttach )

{

	File( myHome + "/DrBrownGeneric.app").execute();

	

	/* this is from the bridge emailer

	 * the problem is that brigde has app.system( "command string" )

	 * Photoshop does not, so I have an app that reads the text file that i create

	if( messageConfig.filesToAttach.length > 0 ) {



		var tempFolder = PhotoshopCS4Emailer.getTempScriptFolder();

		

		var script = new File( tempFolder.fsName + "/BridgeMailerScript.scpt");

		script.open("w");

				

		script.write( "set myPaths to {}" );

		for( f in messageConfig.filesToAttach ) {

			var path = messageConfig.filesToAttach[f];

			script.write(" & \"");

			script.write( path );

			script.write("\"");

		}

		

		script.write("\n");

				

		script.writeln("set filesToAttach to {}");

		script.writeln("repeat with myPath in myPaths");

		script.writeln("\tset filesToAttach to filesToAttach & POSIX file myPath");

		script.writeln("end repeat");

		script.writeln("set mailApp to \"" + messageConfig.mailAppName + "\"");

		script.writeln("tell application mailApp");

		script.writeln("\tactivate");

		script.writeln("\topen filesToAttach");

		script.writeln("end tell");



		script.close();

				

		var cmd = "osascript \"" + script.fsName + "\"";

		// app.system( cmd ); // f... i don't have this command

		

	} // check: at least one file to attach

	 */

			

} 



/* // tpr I don't have a spot to report status in Photoshop */

PhotoshopCS4Emailer.ReportStatus = function( statusInfo )

{

		if( app.document )

		{

			// alert("ReportStatus");

			app.document.status = statusInfo;

		}

}



// A Static Function other scripts can use to send E-mail

//

PhotoshopCS4Emailer.SendEmail = function( messageConfig )

{



	var emailer = new PhotoshopCS4Emailer( messageConfig );

	emailer.sendMessage( messageConfig );

	

}



///////////////////////////////////////////////////////////////////////////////

// Function: FitImage

// Usage: copied and modified from FitImage.jsx

// Input: width height and interpolation method

// Return:

///////////////////////////////////////////////////////////////////////////////

function FitImage( inWidth, inHeight, inInterpolation ) {

	

	if ( inWidth == undefined || inHeight == undefined ) {

		if (emailer.showAlerts) alert( "Width and Height must be defined to use FitImage function!" );

		return;

	}



	var oldPref = app.preferences.rulerUnits;	

	var docWidth;

	var docHeight;

	var docRatio;

	var newWidth;

	var newHeight;

	var resolution = app.activeDocument.resolution;

	

    app.preferences.rulerUnits = Units.PIXELS; // save old preferences



	// original width, height

	docWidth = (1.0 * app.activeDocument.width * resolution) / 72.0; // decimal inches assuming 72 dpi (used in docRatio)

	docHeight = (1.0 * app.activeDocument.height * resolution) / 72.0; // ditto

	

	if (docWidth < 1.0 || docHeight < 1.0)

		return true; // error

	

	if (inWidth < 1 || inHeight < 1)

		return true; // error

	

	docRatio = docWidth / docHeight; // decimal ratio of original width/height

	

	// NOTE - ccox - 17 Aug 2004 - I added the rounding by 0.5

	// this should solve reported cases of fit image being off by 1 (always under)

	// NOTE - elr - 3 May 2006 - keep original aspect ratio

	// NOTE - mshaw- 16 Sept 2007 commenting out lines and adding lines to match fixed FitImage script

	newWidth = inWidth;

	/*newHeight = ((1.0 * inWidth) / docRatio) + 0.5; // decimal calc

	newHeight = 1 * newHeight; // make integer*/

	newHeight = ((1.0 * inWidth) / docRatio); // decimal calc



	

	if (newHeight > inHeight) {

		/*newWidth = 0.5 + docRatio * inHeight; // decimal calc

		newWidth = 1 * newWidth; // make integer*/

		newWidth = docRatio * inHeight; // decimal calc

		newHeight = inHeight;

	}

	

	if ( typeof( inInterpolation ) == "string" ) {

		var interpoArray = { NearestNeighbor:ResampleMethod.NEARESTNEIGHBOR, Bilinear:ResampleMethod.BILINEAR, Bicubic:ResampleMethod.BICUBIC, BicubicSmoother:ResampleMethod.BICUBICSMOOTHER, BicubicSharper:ResampleMethod.BICUBICSHARPER };

		var lookupstring = inInterpolation.replace(" ", "");

		inInterpolation = interpoArray[ lookupstring ];

	} else {

		alert("Bad interpolation : " + typeof( inInterpolation ));

	}



    // resize the image using a good conversion method while keeping the pixel resolution

    // and the aspect ratio the same

    app.activeDocument.resizeImage(newWidth, newHeight, resolution, inInterpolation);

    app.preferences.rulerUnits = oldPref; // restore old prefs



	return false; // no error

}



///////////////////////////////////////////////////////////////////////////////

// Function: CreateUniqueFileName

// Usage:

// Input:

// Return:

///////////////////////////////////////////////////////////////////////////////

function CreateUniqueFileName( inFolder, inFileName, inExtension ) {

	var originalFileName = inFileName;

	inFileName = inFileName.replace(/[:\/\\*\?\"\<\>\|\&]/g, "_");  // '/\:*?"<>|' -> '_'

	// if (inFileName != originalFileName) alert(inFileName +":"+ originalFileName);

	var uniqueFileName = inFolder + inFileName + inExtension;

	var fileNumber = 1;

	while ( File( uniqueFileName ).exists ) {

		uniqueFileName = inFolder + inFileName + "_" + fileNumber + inExtension;

		fileNumber++;

	}

	return uniqueFileName;

}



///////////////////////////////////////////////////////////////////////////////

// Function: FileFolderSplitter

// Usage: Given a full path to a file or a file with an extension or no full

//        path and no extension return the .folder, .name and .extension

// Input: string or File, folder seperator is "/" or "\\"

// Return: object containing .folder, .name and .extension

///////////////////////////////////////////////////////////////////////////////

function FileFolderSplitter( inFullPath ) {

	this.name = inFullPath;

	this.folder = "";

	this.extension = "";

	if ( inFullPath instanceof File || inFullPath instanceof Folder ) {

		this.name = inFullPath.name;

		this.folder = inFullPath.parent.toString();

	} else {

		if ( typeof this.name == 'string' ) {

			var lastSlash = this.name.lastIndexOf( "/" );

			if ( lastSlash == -1 ) {

				lastSlash = this.name.lastIndexOf( "\\" );

			}

			if ( lastSlash != -1 ) {

				this.folder = this.name.substr( 0, lastSlash );

				this.name = this.name.substr( lastSlash + 1, this.name.length );

			}

		}

	}

	// this.name could have the extension but the folder is ready to go

	// so in theory i don't have to worry about . (dots) in folder names

	if ( typeof this.name == 'string' ) {

		var lastDot = this.name.lastIndexOf( "." );

		if ( lastDot == -1 ) {

			lastDot = this.name.length;

		}

		this.extension = this.name.substr( lastDot + 1, this.name.length );

		this.name = this.name.substr( 0, lastDot );

	}

}



emailer.mySave = function( strFilePath ) {



	activeDocument.bitsPerChannel = BitsPerChannelType.EIGHT;



	var jpegOptions = new JPEGSaveOptions();

	jpegOptions.quality = emailer.JPEGQuality;

	jpegOptions.embedColorProfile = true;

	activeDocument.saveAs( File( strFilePath ), jpegOptions, true /* as a copy to get rid of alphas and other stuff */ );



/* was just a save

	var idsave = charIDToTypeID( "save" );

    var desc = new ActionDescriptor();

    var idIn = charIDToTypeID( "In  " );

    desc.putPath( idIn, new File( strFilePath ) );

	executeAction( idsave, desc, DialogModes.NO );

*/



}



emailer.convertTosRGBProfile = function() {

	try {

	var id136 = stringIDToTypeID( "convertToProfile" );

    var desc31 = new ActionDescriptor();

    var id137 = charIDToTypeID( "null" );

        var ref6 = new ActionReference();

        var id138 = charIDToTypeID( "Dcmn" );

        var id139 = charIDToTypeID( "Ordn" );

        var id140 = charIDToTypeID( "Trgt" );

        ref6.putEnumerated( id138, id139, id140 );

    desc31.putReference( id137, ref6 );

    var id141 = charIDToTypeID( "T   " );

    desc31.putString( id141, "sRGB IEC61966-2.1" );

    var id142 = charIDToTypeID( "Inte" );

    var id143 = charIDToTypeID( "Inte" );

    var id144 = charIDToTypeID( "Clrm" );

    desc31.putEnumerated( id142, id143, id144 );

    var id145 = charIDToTypeID( "MpBl" );

    desc31.putBoolean( id145, true );

    var id146 = charIDToTypeID( "Dthr" );

    desc31.putBoolean( id146, true );

	executeAction( id136, desc31, DialogModes.NO );

	desc31 = null;

	ref6 = null;

	$.gc();

	} catch(e) { ; }

}



///////////////////////////////////////////////////////////////////////////////

// Function: fitOnScreen

// Usage: Fit the current image on screen for best view

// Input: <nothing> an open document

// Return: <nothing> altered view

///////////////////////////////////////////////////////////////////////////////

emailer.fitOnScreen = function() {

	var idslct = charIDToTypeID( "slct" );

    var desc106 = new ActionDescriptor();

    var idnull = charIDToTypeID( "null" );

    var ref63 = new ActionReference();

    var idMn = charIDToTypeID( "Mn  " );

    var idMnIt = charIDToTypeID( "MnIt" );

    var idFtOn = charIDToTypeID( "FtOn" );

    ref63.putEnumerated( idMn, idMnIt, idFtOn );

    desc106.putReference( idnull, ref63 );

	executeAction( idslct, desc106, DialogModes.NO );

}



///////////////////////////////////////////////////////////////////////////////

// Function: webSharpen

// Usage: Dr. Brown's magical web sharpen thingy

// Input: <nothing> an active document

// Return: <nothing> a document with some nice sharpining

///////////////////////////////////////////////////////////////////////////////

emailer.webSharpen = function( d ) {

	d.selection.selectAll();

	d.selection.copy();

	emailer.newChannel();

	d.paste();

	emailer.findEdges();

	emailer.showCurrentChannel();

	emailer.runLevels();

	emailer.setSelectionFromChannel();

	emailer.deleteCurrentChannel();

	emailer.smartSharpen();

	d.selection.deselect();

}



///////////////////////////////////////////////////////////////////////////////

// Function: newChannel

// Usage: Make a new channel and give it some properties

// Input: <nothing> an active document

// Return: <nothing> a new channel on the document

///////////////////////////////////////////////////////////////////////////////

emailer.newChannel = function() {

	var idMk = charIDToTypeID( "Mk  " );

    var desc35 = new ActionDescriptor();

    var idNw = charIDToTypeID( "Nw  " );

        var desc36 = new ActionDescriptor();

        var idNm = charIDToTypeID( "Nm  " );

        desc36.putString( idNm, "Edge Mask" );

        var idClrI = charIDToTypeID( "ClrI" );

        var idMskI = charIDToTypeID( "MskI" );

        var idMskA = charIDToTypeID( "MskA" );

        desc36.putEnumerated( idClrI, idMskI, idMskA );

        var idClr = charIDToTypeID( "Clr " );

            var desc37 = new ActionDescriptor();

            var idRd = charIDToTypeID( "Rd  " );

            desc37.putDouble( idRd, 255.000000 );

            var idGrn = charIDToTypeID( "Grn " );

            desc37.putDouble( idGrn, 0.000000 );

            var idBl = charIDToTypeID( "Bl  " );

            desc37.putDouble( idBl, 0.000000 );

        var idRGBC = charIDToTypeID( "RGBC" );

        desc36.putObject( idClr, idRGBC, desc37 );

        var idOpct = charIDToTypeID( "Opct" );

        desc36.putInteger( idOpct, 50 );

    var idChnl = charIDToTypeID( "Chnl" );

    desc35.putObject( idNw, idChnl, desc36 );

	executeAction( idMk, desc35, DialogModes.NO );

}



///////////////////////////////////////////////////////////////////////////////

// Function: findEdges

// Usage: Run the find edges command

// Input: <nothing> an active document

// Return: <nothing> I found all the edges

///////////////////////////////////////////////////////////////////////////////

emailer.findEdges = function() {

	var idFndE = charIDToTypeID( "FndE" );

	executeAction( idFndE, undefined, DialogModes.NO );

}



///////////////////////////////////////////////////////////////////////////////

// Function: showCurrentChannel

// Usage: Show the current channel

// Input: <nothing> an active document

// Return: <nothing> there they are

///////////////////////////////////////////////////////////////////////////////

emailer.showCurrentChannel = function() {

	var idShw = charIDToTypeID( "Shw " );

    var desc66 = new ActionDescriptor();

    var idnull = charIDToTypeID( "null" );

        var list3 = new ActionList();

            var ref40 = new ActionReference();

            var idChnl = charIDToTypeID( "Chnl" );

            var idOrdn = charIDToTypeID( "Ordn" );

            var idTrgt = charIDToTypeID( "Trgt" );

            ref40.putEnumerated( idChnl, idOrdn, idTrgt );

        list3.putReference( ref40 );

    desc66.putList( idnull, list3 );

	executeAction( idShw, desc66, DialogModes.NO );

}



///////////////////////////////////////////////////////////////////////////////

// Function: runLevels

// Usage: Run the levels command with our parameters hard coded

// Input: <nothing> an active document

// Return: <nothing>

///////////////////////////////////////////////////////////////////////////////

emailer.runLevels = function() {

	var idLvls = charIDToTypeID( "Lvls" );

    var desc67 = new ActionDescriptor();

    var idpresetKind = stringIDToTypeID( "presetKind" );

    var idpresetKindType = stringIDToTypeID( "presetKindType" );

    var idpresetKindCustom = stringIDToTypeID( "presetKindCustom" );

    desc67.putEnumerated( idpresetKind, idpresetKindType, idpresetKindCustom );

    var idAdjs = charIDToTypeID( "Adjs" );

        var list4 = new ActionList();

            var desc68 = new ActionDescriptor();

            var idChnl = charIDToTypeID( "Chnl" );

                var ref41 = new ActionReference();

                var idChnl = charIDToTypeID( "Chnl" );

                var idOrdn = charIDToTypeID( "Ordn" );

                var idTrgt = charIDToTypeID( "Trgt" );

                ref41.putEnumerated( idChnl, idOrdn, idTrgt );

            desc68.putReference( idChnl, ref41 );

            var idInpt = charIDToTypeID( "Inpt" );

                var list5 = new ActionList();

                list5.putInteger( 0 );

                list5.putInteger( 223 );

            desc68.putList( idInpt, list5 );

            var idGmm = charIDToTypeID( "Gmm " );

            desc68.putDouble( idGmm, 2.500000 );

            var idOtpt = charIDToTypeID( "Otpt" );

                var list6 = new ActionList();

                list6.putInteger( 60 );

                list6.putInteger( 255 );

            desc68.putList( idOtpt, list6 );

        var idLvlA = charIDToTypeID( "LvlA" );

        list4.putObject( idLvlA, desc68 );

    desc67.putList( idAdjs, list4 );

	executeAction( idLvls, desc67, DialogModes.NO );

}



///////////////////////////////////////////////////////////////////////////////

// Function: setSelectionFromChannel

// Usage: Set the selection from the current channel

// Input: <nothing> an active document

// Return: <nothing>

///////////////////////////////////////////////////////////////////////////////

emailer.setSelectionFromChannel = function() {

	var idsetd = charIDToTypeID( "setd" );

    var desc69 = new ActionDescriptor();

    var idnull = charIDToTypeID( "null" );

        var ref42 = new ActionReference();

        var idChnl = charIDToTypeID( "Chnl" );

        var idfsel = charIDToTypeID( "fsel" );

        ref42.putProperty( idChnl, idfsel );

    desc69.putReference( idnull, ref42 );

    var idT = charIDToTypeID( "T   " );

        var ref43 = new ActionReference();

        var idChnl = charIDToTypeID( "Chnl" );

        var idOrdn = charIDToTypeID( "Ordn" );

        var idTrgt = charIDToTypeID( "Trgt" );

        ref43.putEnumerated( idChnl, idOrdn, idTrgt );

    desc69.putReference( idT, ref43 );

	executeAction( idsetd, desc69, DialogModes.NO );

}



///////////////////////////////////////////////////////////////////////////////

// Function: deleteCurrentChannel

// Usage: Delete the current channel

// Input: <nothing> an active document

// Return: <nothing>

///////////////////////////////////////////////////////////////////////////////

emailer.deleteCurrentChannel = function() {

	var idDlt = charIDToTypeID( "Dlt " );

    var desc72 = new ActionDescriptor();

    var idnull = charIDToTypeID( "null" );

        var ref46 = new ActionReference();

        var idChnl = charIDToTypeID( "Chnl" );

        var idOrdn = charIDToTypeID( "Ordn" );

        var idTrgt = charIDToTypeID( "Trgt" );

        ref46.putEnumerated( idChnl, idOrdn, idTrgt );

    desc72.putReference( idnull, ref46 );

	executeAction( idDlt, desc72, DialogModes.NO );

}



///////////////////////////////////////////////////////////////////////////////

// Function: smartSharpen

// Usage: Run the smart sharpen command

// Input: <nothing> an active document

// Return: <nothing>

///////////////////////////////////////////////////////////////////////////////

emailer.smartSharpen = function() {

	var idsmartSharpen = stringIDToTypeID( "smartSharpen" );

    var desc73 = new ActionDescriptor();

    var idAmnt = charIDToTypeID( "Amnt" );

    var idPrc = charIDToTypeID( "#Prc" );

    desc73.putUnitDouble( idAmnt, idPrc, 60.000000 );

    var idRds = charIDToTypeID( "Rds " );

    var idPxl = charIDToTypeID( "#Pxl" );

    desc73.putUnitDouble( idRds, idPxl, 0.400000 );

    var idThsh = charIDToTypeID( "Thsh" );

    desc73.putInteger( idThsh, 0 );

    var idAngl = charIDToTypeID( "Angl" );

    desc73.putInteger( idAngl, 0 );

    var idmoreAccurate = stringIDToTypeID( "moreAccurate" );

    desc73.putBoolean( idmoreAccurate, true );

    var idblur = charIDToTypeID( "blur" );

    var idblurType = stringIDToTypeID( "blurType" );

    var idlensBlur = stringIDToTypeID( "lensBlur" );

    desc73.putEnumerated( idblur, idblurType, idlensBlur );

    var idpreset = stringIDToTypeID( "preset" );

    desc73.putString( idpreset, "Default" );

    var idsdwM = charIDToTypeID( "sdwM" );

        var desc74 = new ActionDescriptor();

        var idAmnt = charIDToTypeID( "Amnt" );

        var idPrc = charIDToTypeID( "#Prc" );

        desc74.putUnitDouble( idAmnt, idPrc, 0.000000 );

        var idWdth = charIDToTypeID( "Wdth" );

        var idPrc = charIDToTypeID( "#Prc" );

        desc74.putUnitDouble( idWdth, idPrc, 50.000000 );

        var idRds = charIDToTypeID( "Rds " );

        desc74.putInteger( idRds, 1 );

    var idadaptCorrectTones = stringIDToTypeID( "adaptCorrectTones" );

    desc73.putObject( idsdwM, idadaptCorrectTones, desc74 );

    var idhglM = charIDToTypeID( "hglM" );

        var desc75 = new ActionDescriptor();

        var idAmnt = charIDToTypeID( "Amnt" );

        var idPrc = charIDToTypeID( "#Prc" );

        desc75.putUnitDouble( idAmnt, idPrc, 0.000000 );

        var idWdth = charIDToTypeID( "Wdth" );

        var idPrc = charIDToTypeID( "#Prc" );

        desc75.putUnitDouble( idWdth, idPrc, 50.000000 );

        var idRds = charIDToTypeID( "Rds " );

        desc75.putInteger( idRds, 1 );

    var idadaptCorrectTones = stringIDToTypeID( "adaptCorrectTones" );

    desc73.putObject( idhglM, idadaptCorrectTones, desc75 );

	executeAction( idsmartSharpen, desc73, DialogModes.NO );

}



///////////////////////////////////////////////////////////////////////////////

// Function: stringToUnitValue

// Usage: Convert a string to a UnitValue, "6px" "6 px" et. al.

// Input: string of the number and units, could just be number and I will make

//        in pixel unites

// Return: UnitValue

///////////////////////////////////////////////////////////////////////////////

emailer.stringToUnitValue = function(inString) {

	var unitValue = "";

	var unitType = "";

	var findingNumbers = 0;

	var findingStrings = 1;

	var findingWhat = findingNumbers;

	

	for (var i = 0; i < inString.length; i++) {

		if ( ( findingWhat == findingNumbers ) && 

		     ( ( inString[i] >= "0" && inString[i] <= "9" ) ||

		     ( inString[i] == "." ) ) ) {

			unitValue += inString[i];

		} else {

			findingWhat = findingStrings;

		}

		if (findingWhat == findingStrings && inString[i] != " ") {

			unitType += inString[i];

		}

	}

	

	if (unitType.length == 0)

		unitType = "px";



	return new UnitValue(unitValue, unitType);

}



///////////////////////////////////////////////////////////////////////////////

// Function: unitsToPixels

// Usage: convert a number in the given units to pixels

// Input: value in the current units

//        units of the value to convert

//        resolution of the current value

//        value in pixels for percent conversion 

//        (How exaclty am I supposed to pass that in!)

// Return: value in pixels 

///////////////////////////////////////////////////////////////////////////////

emailer.unitsToPixels = function( value, units, resolution, docValue ) {

    var n = Number( value );

    if ( units.search( "in" ) != -1 ) {

        n = value * resolution;

        return n;

    }

    if ( units.search( "cm" ) != -1 ) {

        n = value / 2.54 * resolution;

        return n;

    }

    if ( units.search( "mm" ) != -1 ) {

        n = value / 25.4 * resolution;

        return n;

    }

    if ( units.search( "points" ) != -1 ) {

        n = value * resolution / 72.72;

        return n;

    }

    if ( units.search( "picas" ) != -1 ) {

        n = value * resolution / 72;

        return n;

    }

    if ( ( units.search( "%" ) != -1 ) && ( docValue != undefined ) ) {

        n = value * docValue / 100.0;

        return n;

    }

    return n;

}

// i didn't indent cuz that would be annoying

} // end if BridgeTalk == "photoshop"



// i didn't indent cuz that would be annoying

} // end overall try catch block

catch(e) {

	if (emailer.showAlerts) {

		alert( e + " : " + e.line );

	}

}

// end EMailerService.jsx

